Subject: bug#20427: closed (Re: bug#20427: bug in optimizing compiler?)

From: [email-masked] (GNU bug Tracking System)
Date: Mon, 27 Apr 2015 04:05:05 +0000

Your bug report

#20427: bug in optimizing compiler?

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
20427: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=20427
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#20427: bug in optimizing compiler?
From: Stefan Monnier <[email-masked]>
To: Rafael D Sorkin <[email-masked]>
Cc: [email-masked]
Date: Mon, 27 Apr 2015 00:04:05 -0400
List-Id: <debbugs-submit.debbugs.gnu.org>

tags 20427 notabug
thanks

> When I byte-compile a file containing the following code, with
> optimization safety=0, the compiler deletes the assertion test.

That's expected.  Just like C's `assert', CL's `assert' can be compiled
out depending on compilation options (in this case, depending on the
`safety' setting).

        Stefan

Subject: bug in optimizing compiler?
From: Rafael D Sorkin <[email-masked]>
To: [email-masked]
Date: Sun, 26 Apr 2015 00:15:51 -0400
List-Id: <debbugs-submit.debbugs.gnu.org>

The following report refers to this version of emacs: 

  GNU Emacs 24.3.1 (x86_64-pc-linux-gnu, GTK+ Version 3.10.7) of
  2014-03-07 on lamiak, modified by Debian

Hello,

When I byte-compile a file containing the following code, with
optimization safety=0, the compiler deletes the assertion test.

  (defmacro buggy ()
    (assert nil nil "assertion failed -- it always should fail")
    "This should never show up!")

This only seems to happen when i compile a file containing the
macro, not when i compile the macro individually.
Here is a full example 
(the defmacro of `buggy' is in the file "bug.test.el")

  (declaim (optimize  (safety 3)))
  (byte-compile-file "bug.test.el" 'load)	; t
  (buggy)					; error: "assertion failed -- it always should fail"

  (declaim (optimize  (safety 0)))
  (byte-compile-file "bug.test.el" 'load)	; t
  (buggy)					; This should never show up!

I'm not sure whether this officially qualifies as a bug, but
it's certainly not the behavior I was expecting.  (It also
doesn't seem to be present in Emacs 23.1.1)

Thanks,
Rafael

~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-
 Rafael Sorkin
 Perimeter Institute for Theoretical Physics
 31 Caroline Street North
 Waterloo, ON  N2L 2Y5
 Canada
~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-